<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\View;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Illuminate\Support\Facades\DB;
use App\Article;
use DateTime;

class ArticleController extends Controller
{
    private function convDate($data_italiana)
    {
        return DateTime::createFromFormat('Y-m-d', $data_italiana)->format('Y-d-m');
    }
    private function articoliByDataStart($data_start)
    {
        $data_start = $this->convDate($data_start);
        $data_start = $data_start . ' 00:00:00';
        ini_set("memory_limit", "512M");
        try {
            $articoli = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                    ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
            })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as totVen, MAX(DataOra) as ultimaDataOra FROM T_WEB_Ordini WHERE DataOra > \'' . $data_start . '\' GROUP BY CodArticoloGM) O'), 'T_WEB_Articoli.IdArticolo', '=', 'O.CodArticoloGM')
                ->leftJoin(DB::raw('(SELECT g.IdTipologia, g.Descrizione as DescrizioneTipologia FROM T_WEB_Tipologie g JOIN (SELECT IdTipologia, MAX(DataOra) as data1 from T_WEB_Tipologie GROUP BY IdTipologia) h ON g.IdTipologia = h.IdTipologia AND g.DataOra = h.data1 ) i'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipologia', '=', 'i.IdTipologia');
                })
                ->select('T_WEB_Articoli.*', 'ultimaDataOra', DB::raw('COALESCE(O.totVen, 0) as totVen'))
                ->where('totVen', '>', 0)
                ->where('DescrizioneTipologia', 'Libri')
                ->orderBy('totVen', 'desc')
                ->get();

            // var_dump($articoli->toArray());

            if ($articoli->isEmpty()) {
                return ['error' => 'Nessun articolo'];
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return ['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()];
        }

        return $articoli;

    }
    private function queryOrdini($numrec)
    {
        ini_set("memory_limit", "512M");
        try {
            $ordini = DB::table('T_WEB_Ordini as O')
                ->leftJoin(DB::raw('(
                SELECT
                    IdArticolo,
                    MAX(DataOra) as data
                FROM T_WEB_Articoli
                GROUP BY IdArticolo
            ) b'), 'O.CodArticoloGM', '=', 'b.IdArticolo')
                ->join('T_WEB_Articoli as A', function ($join) {
                    $join->on('O.CodArticoloGM', '=', 'A.IdArticolo')
                        ->on('b.data', '=', 'A.DataOra');
                })
                ->select(
                    DB::raw('ROW_NUMBER() OVER (ORDER BY O.DataOra DESC) AS progressivo'),
                    'O.DataOra',
                    'O.Qta',
                    'A.Titolo',
                    'A.Ean13'
                )
                ->orderBy('O.DataOra', 'desc')
                ->take($numrec)
                ->get();

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $ordini;

    }
    private function queryOrdiniByIdArticolo($idArticolo)
    {
        ini_set("memory_limit", "512M");
        try {
            $ordini = DB::table('T_WEB_Ordini as O')
                ->leftJoin(DB::raw('(
                SELECT
                    IdArticolo,
                    MAX(DataOra) as data
                FROM T_WEB_Articoli
                GROUP BY IdArticolo
            ) b'), 'O.CodArticoloGM', '=', 'b.IdArticolo')
                ->join('T_WEB_Articoli as A', function ($join) {
                    $join->on('O.CodArticoloGM', '=', 'A.IdArticolo')
                        ->on('b.data', '=', 'A.DataOra');
                })
                ->select(
                    DB::raw('ROW_NUMBER() OVER (ORDER BY O.DataOra DESC) AS progressivo'),
                    'O.DataOra',
                    'O.Qta',
                    'A.Titolo',
                    'A.Ean13'
                )
                ->orderBy('O.DataOra', 'desc')
                ->where('O.CodArticoloGM', '=', $idArticolo)
                ->get();

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $ordini;

    }
    private function queryshowInfoArticolo($idArticolo)
    {
        try {
            ini_set("memory_limit", "512M");

            $articoli = Article::where('IdArticolo', $idArticolo)
                ->get(); // Usa 

            if ($articoli->isEmpty()) {
                return ['error' => 'Nessun articolo'];
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return ['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()];
        }

        return $articoli;
    }
    private function queryArticlesSales()
    {
        try {
            ini_set("memory_limit", "512M");

            $articoliVenduti = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                    ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
            })
                ->leftJoin(DB::raw('(SELECT e.IdStatoProdotto, e.Descrizione as DescrizioneStatoProdotto FROM T_WEB_StatiProdotto e JOIN (SELECT IdStatoProdotto, MAX(DataOra) as data1 from T_WEB_StatiProdotto GROUP BY IdStatoProdotto) c ON e.IdStatoProdotto = c.IdStatoProdotto AND e.DataOra = c.data1 ) f'), function ($join) {
                    $join->on('T_WEB_Articoli.IdStatoProdotto', '=', 'f.IdStatoProdotto');
                })
                ->leftJoin(DB::raw('(SELECT g.IdTipologia, g.Descrizione as DescrizioneTipologia FROM T_WEB_Tipologie g JOIN (SELECT IdTipologia, MAX(DataOra) as data1 from T_WEB_Tipologie GROUP BY IdTipologia) h ON g.IdTipologia = h.IdTipologia AND g.DataOra = h.data1 ) i'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipologia', '=', 'i.IdTipologia');
                })
                ->leftJoin(DB::raw('(SELECT l.IdTipoFormato, l.Descrizione as DescrizioneFormato FROM T_WEB_TipiFormato l JOIN (SELECT IdTipoFormato, MAX(DataOra) as data1 from T_WEB_TipiFormato GROUP BY IdTipoFormato) m ON l.IdTipoFormato = m.IdTipoFormato AND l.DataOra = m.data1 ) n'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipoFormato', '=', 'n.IdTipoFormato');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as totVen FROM T_WEB_Ordini GROUP BY CodArticoloGM) o'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'o.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as venduti3mesi, RANK() OVER (ORDER BY SUM(Qta) DESC) as rank3M
                        FROM T_WEB_Ordini 
                        WHERE DataOra >= DATEADD(MONTH, -3, GETDATE())
                        GROUP BY CodArticoloGM) p'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'p.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as venduti6mesi, RANK() OVER (ORDER BY SUM(Qta) DESC) as rank6M 
                        FROM T_WEB_Ordini 
                        WHERE DataOra >= DATEADD(MONTH, -6, GETDATE())
                        GROUP BY CodArticoloGM) q'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'q.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as venduti1anno, RANK() OVER (ORDER BY SUM(Qta) DESC) as rank1Y
                        FROM T_WEB_Ordini 
                        WHERE DataOra >= DATEADD(MONTH, -12, GETDATE())
                        GROUP BY CodArticoloGM) r'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'r.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, MAX(DataOra) as ultimoOrdine 
                        FROM T_WEB_Ordini 
                        GROUP BY CodArticoloGM) s'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 's.CodArticoloGM');
                })
                ->select(
                    'T_WEB_Articoli.*',
                    'f.DescrizioneStatoProdotto',
                    'i.DescrizioneTipologia',
                    'n.DescrizioneFormato',
                    DB::raw('COALESCE(o.totVen, 0) as totVen'),
                    DB::raw('COALESCE(p.venduti3mesi, 0) as venduti3mesi'),
                    DB::raw('COALESCE(p.rank3M, 0) as rank3M'),
                    DB::raw('COALESCE(q.venduti6mesi, 0) as venduti6mesi'),
                    DB::raw('COALESCE(q.rank6M, 0) as rank6M'),
                    DB::raw('COALESCE(r.venduti1anno, 0) as venduti1anno'),
                    DB::raw('COALESCE(r.rank1Y, 0) as rank1Y'),
                    DB::raw('s.ultimoOrdine')
                )
                ->where('DescrizioneStatoProdotto', 'In commercio')
                ->where('DescrizioneTipologia', 'Libri')
                //->orderBy('rank1Y', 'asc')
                ->orderBy('totVen', 'desc')
                ->get();

            if ($articoliVenduti->isEmpty()) {
                return response()->json(['message' => 'Nessun articolo trovato.'], 404);
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $articoliVenduti;

    }

    public function showArticlesSales(Request $request)
    {
        try {

            $articoliVenduti = $this->queryArticlesSales();

            return view('export_articles_sales', ['articoliVenduti' => $articoliVenduti]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);

        }
    }
    public function showArticoliByDataStart($data_start)
    {
        try {
            $this->validateDate($data_start);

            $articoliVenduti = $this->articoliByDataStart($data_start);

            if ($articoliVenduti && isset($articoliVenduti['error'])) {
                return view('error', ['message' => $articoliVenduti['error']]);
            }

            return view('view-lista-ordini-totale', ['articoli' => $articoliVenduti]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);


        }
    }
    protected function validateDate($date)
    {
        $validator = \Validator::make(['data_start' => $date], [
            'data_start' => 'required|date_format:Y-m-d'
        ]);

        if ($validator->fails()) {
            throw new ValidationException($validator);
        }
    }

    public function showOrdini($numrec)
    {
        try {

            $ordini = $this->queryOrdini($numrec);

            return view('ordini_test', ['ordini' => $ordini]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);

        }
    }
    public function showOrdiniByIdArticolo($idArticolo)
    {
        try {

            $ordini = $this->queryOrdiniByIdArticolo($idArticolo);

            return view('ordini_test', ['ordini' => $ordini]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);

        }
    }
    public function showInfoArticolo($idArticolo)
    {
        try {

            $articoli = $this->queryshowInfoArticolo($idArticolo);

            if ($articoli && isset($articoli['error'])) {
                return view('error', ['message' => $articoli['error']]);
            }

            return view('info-articolo', ['articoli' => $articoli]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);

        }
    }
    public function exportArticlesSales(Request $request): Response
    {
        try {

            $articoliVenduti = $this->queryArticlesSales();

            $filename = 'articoli_venduti_' . date('Y-m-d') . '.csv';
            $response = new Response();
            $response->headers->set('Content-Type', 'text/csv');
            $response->headers->set('Content-Disposition', 'attachment; filename="' . $filename . '"');


            $csvContent = "IdArticolo,Titolo,DataPubblicazione,Ean13,rank3M,rank6M,rank1Y,totVen,totVenUltimoMese,totVenUltimi6Mesi,totVenUltimoAnno,totVenUltimi2Anni,UltimoOrdine,misure\n";

            foreach ($articoliVenduti as $articoloVenduto) {
                $csvContent .= "{$articoloVenduto->idArticolo},{$articoloVenduto->Titolo},{$articoloVenduto->DataPubblicazione},{$articoloVenduto->rank3M},{$articoloVenduto->rank6M},{$articoloVenduto->rank1Y},{$articoloVenduto->totVen},{$articoloVenduto->venduti3mesi},{$articoloVenduto->venduti6mesi},{$articoloVenduto->venduti1anno},{$articoloVenduto->ultimoOrdine},{$articoloVenduto->misure}\n";
            }

            $response->setContent($csvContent);
            return $response;

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);
        }
    }

    public function exportArticlesSalesByJSON(Request $request): Response
    {
        try {
            // Recupera gli articoli venduti
            $articoliVenduti = $this->queryArticlesSales();

            // Mappa i risultati nella struttura JSON desiderata
            $result = $articoliVenduti->map(function ($articoloVenduto) {
                return [
                    'IdArticolo' => $articoloVenduto->IdArticolo,
                    'title' => $articoloVenduto->Titolo,
                    'DataPubblicazione' => $articoloVenduto->DataPubblicazione,
                    'isbn' => $articoloVenduto->Ean13,
                    'Pagine' => $articoloVenduto->Pagine,
                    'IdTipoFormato' => $articoloVenduto->IdTipoFormato,
                    'misure' => $articoloVenduto->misure,
                    'totVen' => $articoloVenduto->totVen,
                    'rank3M' => $articoloVenduto->rank3M,
                    'rank6M' => $articoloVenduto->rank6M,
                    'rank1Y' => $articoloVenduto->rank1Y,
                    'vLast3M' => $articoloVenduto->venduti3mesi,
                    'vLast6M' => $articoloVenduto->venduti6mesi,
                    'vLastY' => $articoloVenduto->venduti1anno,
                    'dataUltimoOrdine' => $articoloVenduto->ultimoOrdine,
                ];
            });

            // Imposta il contenuto della risposta come JSON
            $response = new Response($result->toJson(), 200);
            $response->headers->set('Content-Type', 'application/json');
            $response->headers->set('Content-Disposition', 'attachment; filename="ranking_' . date('Y-m-d') . '.json"');

            return $response;

        } catch (\Exception $e) {
            return new Response('Error exporting articles: ' . $e->getMessage(), 500);
        }
    }

    public function test(Request $request)
    {
        try {

            $articoli = $this->queryTest2();

            dd($articoli);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Erroe test: ' . $e->getMessage(), 500);

        }
    }
    public function queryTest2()
    {
        try {
            $duplicati = DB::table('T_WEB_Articoli')
                ->select('idArticolo', 'Titolo', 'DataPubblicazione', 'Ean13', DB::raw('count(*) as total'))
                ->groupBy('idArticolo', 'Titolo', 'DataPubblicazione', 'Ean13')
                ->having('total', '>', 0) // Filtra duplicati
                ->get();


            return $duplicati;

        } catch (\Exception $e) {
            return new Response('Errore: ' . $e->getMessage(), 500);
        }

    }

}